<?php
// C:\workfolder\zeedhi-dyman\projects\avaliacao\src\Service\SecurityService.php
namespace Teknisa\CRM\Service;

class SecurityService{

	private $cdoperador;
    private $nmoperador;
    private $nrGroupCtlAcess;
    private $nrOrg;
    private $nrParcNegocio;
    private $cdfilial;

	/**
	**/
	public function __construct($entityManager) {
		$this->entityManager = $entityManager;
	}

	public function validateOrg($nrorg){
		$std = $this->entityManager->getConnection()->prepare("SELECT o.* FROM ORGANIZACAO o WHERE o.NRORG = $nrorg");
		$std->execute();
		return count($std->fetchAll())>0;
	}

	public function validateFilial($cdfilial, $nrorg){
		$std = $this->entityManager->getConnection()->prepare("SELECT f.* FROM FILIAL f WHERE f.CDFILIAL = $cdfilial AND f.NRORG = $nrorg");
		$std->execute();
		return count($std->fetchAll())>0;
	}

	public function validateOperador($cdoperador){
		if (is_numeric($cdoperador)) {

		    $cdoperador = str_pad($cdoperador, 12, "0", STR_PAD_LEFT);
            $std = $this->entityManager->getConnection()->prepare("SELECT o.CDOPERADOR, o.NMOPERADOR, o.CDFUNC, o.NRPARCNEGOCIO, f.CDFILIAL, o.NRORG FROM OPERADOR o LEFT JOIN FILIOPER f ON o.CDOPERADOR = f.CDOPERADOR WHERE o.CDOPERADOR = '" . $cdoperador . "'");
            $std->execute();
            $result = $std->fetchAll();
            if ($result) {
                $this->cdoperador      = $result[0]["CDOPERADOR"];
                $this->nmoperador      = $result[0]["NMOPERADOR"];
                $this->nrGroupCtlAcess = $result[0]["CDFUNC"];
                $this->nrParcNegocio   = $result[0]["NRPARCNEGOCIO"];
                $this->nrOrg           = $result[0]["NRORG"];
                $this->cdfilial        = $result[0]["CDFILIAL"];
            }

		} else {

            $cdoperador = strtolower($cdoperador);
		    $std = $this->entityManager->getConnection()->prepare("SELECT o.CDOPERADOR, o.NMOPERADOR, o.CDFUNC, o.NRPARCNEGOCIO, f.CDFILIAL, o.NRORG FROM OPERADOR o LEFT JOIN FILIOPER f ON o.CDOPERADOR = f.CDOPERADOR WHERE o.DSEMAILOPER = '" . $cdoperador . "'");
            $std->execute();
            $result = $std->fetchAll();
            if ($result) {
                $this->cdoperador      = $result[0]["CDOPERADOR"];
                $this->nmoperador      = $result[0]["NMOPERADOR"];
                $this->nrGroupCtlAcess = $result[0]["CDFUNC"];
                $this->nrParcNegocio   = $result[0]["NRPARCNEGOCIO"];
                $this->nrOrg           = $result[0]["NRORG"];
                $this->cdfilial        = $result[0]["CDFILIAL"];
            }

		}

		return count($result)>0;
	}

	public function validateSenha($cdoperador, $cdsenhaoperweb){
        $nrorg = $this->nrOrg;
		$senhaEncrypt = md5($cdsenhaoperweb);
		$this->validaSenhaNull($cdoperador, $senhaEncrypt, $nrorg);
		$std = $this->entityManager->getConnection()->prepare("SELECT o.CDOPERADOR, o.CDSENHAOPERWEB FROM OPERADOR o WHERE o.CDOPERADOR = '" . $this->cdoperador . "' AND o.CDSENHAOPERWEB = '$senhaEncrypt'");
		$std->execute();
		return count($std->fetchAll())>0;
	}

	private function validaSenhaNull($cdoperador, $senha, $nrorg)
	{
		$std = $this->entityManager->getConnection()->prepare("SELECT o.CDSENHAOPERWEB FROM OPERADOR o WHERE o.CDOPERADOR = '$cdoperador' AND o.NRORG = $nrorg");
		$std->execute();
		$result = $std->fetchAll();
		if ((bool)$result && $result[0]["CDSENHAOPERWEB"] == null) {
			$std = $this->entityManager->getConnection()->prepare("UPDATE OPERADOR SET CDSENHAOPERWEB = '$senha' WHERE CDOPERADOR = '$cdoperador' AND NRORG = '$nrorg'");
			$std->execute();
		}
	}

    public function getNmestrutLegalHierarquiaOper($cdoperador) {
        $nrorg = $this->nrOrg;

        $sql = "SELECT EM2.NMESTRUTURAM
  FROM PARCNEGOCIO
  JOIN GPE_PESSOA
    ON GPE_PESSOA.NRPARCNEGOCIO = PARCNEGOCIO.NRPARCNEGOCIO
   AND GPE_PESSOA.NRORG         = PARCNEGOCIO.NRORG
  JOIN GPE_VINCULOM VM
    ON VM.NRPESSOA       = GPE_PESSOA.NRPESSOA
   AND VM.NRORG          = GPE_PESSOA.NRORG
   AND VM.NRVINCULOM     = (SELECT NRVINCULOM
                             FROM (SELECT ROWNUM NUMB, VINC.NRVINCULOM FROM (
                                          SELECT GPE_VINCULOM.NRVINCULOM
                                            FROM GPE_VINCULOM
                                           WHERE GPE_VINCULOM.NRORG          = GPE_PESSOA.NRORG
                                             AND GPE_VINCULOM.NRPESSOA       = GPE_PESSOA.NRPESSOA
                                             AND GPE_VINCULOM.DTADMISSAOVINC = (SELECT MAX(DTADMISSAOVINC)
                                                                                FROM GPE_VINCULOM VINCULOM
                                                                               WHERE VINCULOM.NRORG           = GPE_VINCULOM.NRORG
                                                                                 AND VINCULOM.NRPESSOA        = GPE_VINCULOM.NRPESSOA
                                                                                 AND VINCULOM.DTADMISSAOVINC <= TO_DATE('01/04/2015', 'DD/MM/YYYY')) ORDER BY GPE_VINCULOM.DTRESCISAOVINC DESC) VINC) VINCULOM
                            WHERE VINCULOM.NUMB = 1)
  JOIN GPE_VINCULOH VH
    ON VH.NRVINCULOM     = VM.NRVINCULOM
   AND VH.NRORG          = VM.NRORG
   AND VH.DTMESCOMPETENC = (SELECT MAX(GPE_VINCULOH.DTMESCOMPETENC)
                              FROM GPE_VINCULOH
                             WHERE GPE_VINCULOH.NRORG      = VM.NRORG
                               AND GPE_VINCULOH.NRVINCULOM = VM.NRVINCULOM
                               AND GPE_VINCULOH.DTMESCOMPETENC <= TO_DATE('01/04/2015', 'DD/MM/YYYY'))
  JOIN ESTRUTURAM EM2
    ON EM2.NRESTRUTURAM = (CASE
                             WHEN GET_NRESTRUTURA_SUPERIOR_H(VH.NRORG,
                                                             VH.NRESTRUTGEREN,
                                                             1, 26,
                                                             TO_DATE('01/04/2015', 'DD/MM/YYYY')) IS NULL

                             THEN GET_NRESTRUTURA_SUPERIOR_H(VH.NRORG,
                                                             VH.NRESTRUTGEREN,
                                                             1, 27,
                                                             TO_DATE('01/04/2015', 'DD/MM/YYYY'))

                             ELSE GET_NRESTRUTURA_SUPERIOR_H(VH.NRORG,
                                                             VH.NRESTRUTGEREN,
                                                             1, 26,
                                                             TO_DATE('01/04/2015', 'DD/MM/YYYY'))
                                 END)
   AND EM2.NRORG        = VH.NRORG
  WHERE PARCNEGOCIO.NRORG         = 20
   AND PARCNEGOCIO.NRPARCNEGOCIO = (SELECT NRPARCNEGOCIO
                                      FROM OPERADOR
                                     WHERE NRORG = '$nrorg'
                                       AND (OPERADOR.CDOPERADOR = LPAD('$cdoperador', 12, 0) OR OPERADOR.CDOPERADOR = '$cdoperador'))";

        $std = $this->entityManager->getConnection()->prepare($sql);
        $std->execute();
        $result = $std->fetchAll();
        if ($result) {
            return $result[0]["NMESTRUTURAM"];
        }

    }

    public function getNrorg()
    {
        return $this->nrOrg;
    }

    public function getCdfilial()
    {
        return $this->cdfilial;
    }

	public function getCdoperador()
	{
		return $this->cdoperador;
	}

    public function getNmoperador()
    {
        return $this->nmoperador;
    }

    public function getNrGroupCtlAcess()
    {
        return $this->nrGroupCtlAcess;
    }

    public function getNrParcNegocio()
    {
        return $this->nrParcNegocio;
    }
}