function ShortcutDeveloperService(metaDataFactory){
    var shortcut_widgets = {};
    var DEFAULT_WIDGET = {
        "isVisible": true,
        "template": "widget/form.html",
        "actions": []
    };
    var DEFAULT_CONTAINER = {
        "showHeader": false,
        "height": "100%",
        "isVisible": true,
        "showFooter": false,
        "footer": "component/footer.html",
        "template": "container/window.html",
        "addToHistory": false,
        "widgets": []
    };

    function createFields(fieldsToCreate){
        var fields = Object.keys(fieldsToCreate).map(function(value){
            var field = fieldsToCreate[value];
            field.id = (+new Date());
            field.name = value;
            field = metaDataFactory.fieldFactory(field);
            return field;
        });
        return fields;
    }

    function getDefaultWidget(widgetName, fields){
        var widget = DEFAULT_WIDGET;
        widget.fields = createFields(fields);
        widget.name = widgetName;
        widget.label = widgetName;
        widget.id = (+new Date());
        return widget;
    }

    function getDefaultContainer(widgetName){
        var container = DEFAULT_CONTAINER;
        container.name = "container" + widgetName;
        container.label = "container" + widgetName;
        container.id = (+new Date());
        return container;
    }

    this.createWidgetAndContainer = function(widgetName, fields, hideFunction){
        if(!shortcut_widgets[widgetName]){
            var widget = getDefaultWidget(widgetName, fields);
            var container = getDefaultContainer(widgetName);
            widget.hideWidget = hideFunction;
            container.widgets[0] = widget;
            container = metaDataFactory.containerFactory(container);
            shortcut_widgets[widgetName] = metaDataFactory.widgetFactory(widget, container);
        }
    };

    this.hideWidget = function(widget){
        var widgetToHide = widget ? shortcut_widgets[widget.name] : undefined;
        if(widgetToHide){
            widgetToHide.hideWidget();
        }
    };

    this.getWidgetAndContainerToShow = function(widgetName){
        var widgetAndContainer = {};
        var shortcutWidget = shortcut_widgets[widgetName];
        if(shortcutWidget){
            widgetAndContainer.widget = shortcutWidget;
            widgetAndContainer.container = shortcutWidget.container;
        }
        return widgetAndContainer;
    };
}